diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initialization-invalid2.vert b/tests/spec/arb_arrays_of_arrays/compiler/initialization-invalid2.vert
index 23da9ce..4c848fb 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initialization-invalid2.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initialization-invalid2.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: fail
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initialization-invalid3.vert b/tests/spec/arb_arrays_of_arrays/compiler/initialization-invalid3.vert
index 412088f..a21bbe8 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initialization-invalid3.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initialization-invalid3.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: fail
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initialization-invalid4.vert b/tests/spec/arb_arrays_of_arrays/compiler/initialization-invalid4.vert
index 4c32e97..ecfaaba 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initialization-invalid4.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initialization-invalid4.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: fail
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initializer-array-array-var.vert b/tests/spec/arb_arrays_of_arrays/compiler/initializer-array-array-var.vert
index 993bf60..f940c56 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initializer-array-array-var.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initializer-array-array-var.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: pass
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initializer-array-array-var2.vert b/tests/spec/arb_arrays_of_arrays/compiler/initializer-array-array-var2.vert
index 7e77f3e..db7cfdd 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initializer-array-array-var2.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initializer-array-array-var2.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: pass
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initializer-array-var-array.vert b/tests/spec/arb_arrays_of_arrays/compiler/initializer-array-var-array.vert
index d4c7e58..8cb4a80 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initializer-array-var-array.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initializer-array-var-array.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: pass
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initializer-array-var-array2.vert b/tests/spec/arb_arrays_of_arrays/compiler/initializer-array-var-array2.vert
index 2a93dda..2e13839 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initializer-array-var-array2.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initializer-array-var-array2.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: pass
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initializer-dec-list-type-array-array-var1-var2.vert b/tests/spec/arb_arrays_of_arrays/compiler/initializer-dec-list-type-array-array-var1-var2.vert
index 287fadd..124471e 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initializer-dec-list-type-array-array-var1-var2.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initializer-dec-list-type-array-array-var1-var2.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: pass
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initializer-dec-list-type-array-var1-array-var2-array.vert b/tests/spec/arb_arrays_of_arrays/compiler/initializer-dec-list-type-array-var1-array-var2-array.vert
index 844081a..de72af2 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initializer-dec-list-type-array-var1-array-var2-array.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initializer-dec-list-type-array-var1-array-var2-array.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: pass
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initializer-dec-list-type-var1-array-array-var2-array-array.vert b/tests/spec/arb_arrays_of_arrays/compiler/initializer-dec-list-type-var1-array-array-var2-array-array.vert
index c7c97e4..eb12cf7 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initializer-dec-list-type-var1-array-array-var2-array-array.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initializer-dec-list-type-var1-array-array-var2-array-array.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: pass
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-array-array-var.vert b/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-array-array-var.vert
index 1d0cedf..dc341b7 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-array-array-var.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-array-array-var.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: pass
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-array-var-array.vert b/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-array-var-array.vert
index 5afc308..467b29a 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-array-var-array.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-array-var-array.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: pass
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-array-var-array2.vert b/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-array-var-array2.vert
index 15e24ce..2743cbc 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-array-var-array2.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-array-var-array2.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: pass
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-dec-list-array-array-var1-var2.vert b/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-dec-list-array-array-var1-var2.vert
index b0abb4a..7ffafaf 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-dec-list-array-array-var1-var2.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-dec-list-array-array-var1-var2.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: pass
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-dec-list-array-var1-array-var2.vert b/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-dec-list-array-var1-array-var2.vert
index 782349b..cca8c95 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-dec-list-array-var1-array-var2.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-dec-list-array-var1-array-var2.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: pass
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-dec-list-array-var1-var2-array.vert b/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-dec-list-array-var1-var2-array.vert
index 6663337..7a03990 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-dec-list-array-var1-var2-array.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-dec-list-array-var1-var2-array.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: pass
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-var-array-array.vert b/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-var-array-array.vert
index 72ccacf..d7506e4 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-var-array-array.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initializer-struct-field-var-array-array.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: pass
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initializer-three-dimensions.vert b/tests/spec/arb_arrays_of_arrays/compiler/initializer-three-dimensions.vert
index a0e06a6..6905938 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initializer-three-dimensions.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initializer-three-dimensions.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: pass
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initializer-three-dimensions2.vert b/tests/spec/arb_arrays_of_arrays/compiler/initializer-three-dimensions2.vert
index 03a1e83..ff300d0 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initializer-three-dimensions2.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initializer-three-dimensions2.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: pass
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initializer-var-array-array.vert b/tests/spec/arb_arrays_of_arrays/compiler/initializer-var-array-array.vert
index 8a53cb7..1c81079 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initializer-var-array-array.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initializer-var-array-array.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: pass
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120
diff --git a/tests/spec/arb_arrays_of_arrays/compiler/initializer-var-array-array2.vert b/tests/spec/arb_arrays_of_arrays/compiler/initializer-var-array-array2.vert
index 41fd76b..65f9e75 100644
--- a/tests/spec/arb_arrays_of_arrays/compiler/initializer-var-array-array2.vert
+++ b/tests/spec/arb_arrays_of_arrays/compiler/initializer-var-array-array2.vert
@@ -1,8 +1,7 @@
 /* [config]
  * expect_result: pass
  * glsl_version: 1.20
- * require_extensions: GL_ARB_arrays_of_arrays
- * require_extensions: GL_ARB_shading_language_420pack
+ * require_extensions: GL_ARB_arrays_of_arrays GL_ARB_shading_language_420pack
  * [end config]
  */
 #version 120